unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, system.Diagnostics,
  Vcl.ExtCtrls, system.UITypes;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    tanX: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    Clearbtn: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    procedure tanXClick(Sender: TObject);
    procedure ClearbtnClick(Sender: TObject);
  private
    { Private 錾 }
    function incheck(s, m: string): boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Velthuis.BigIntegers, Velthuis.Bigdecimals;

var
  t : array of biginteger;

// ΂̒l
function big_pi(pcs: integer): Bigdecimal;
var
  n, dpcs, pcsBack : integer;
  rmback : BigDecimal.RoundingMode;
  SQRT_SQRT_EPSILON, c, b, e : BigDecimal;
  npow : Bigdecimal;
  a, one, two, four, five, eight : Bigdecimal;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcs + 5;                                    // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := '1';
  one := one.RoundToPrecision(dpcs);                  // one̗Ldpcsɐݒ
  two := '2';
  four := '4';
  five := '5';
  eight := '8';
  SQRT_SQRT_EPSILON := one / BigDecimal.IntPower(two, pcs shl 0); // l
  c := BigDecimal.Sqrt(one / eight, dpcs * 2);
  a := one + c + c + c;
  b := BigDecimal.Sqrt(a, dpcs * 2);
  e := b - five / eight;
  b := b + b;
  c := e - c;
  a := a + e;
  npow := '4';
  n := 0;
  while e > SQRT_SQRT_EPSILON do begin
    npow := npow + npow;
    e := (a + b) / two;                               // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +  ۂ
    b := BigDecimal.Sqrt(b, dpcs * 2);                // Lł̊ۂ
    e := e - b;
    b := b + b;
    c := c - e;
    a := e + b;
    inc(n);
  end;
  e := e * e;
  e := e.RoundToPrecision(dpcs);                      // pcs +  ۂ
  e := e / four;                                      // e = e + e / 4
  a := a + b;
  result := (a * a - e - e / two) / (a * c - e) / npow;   // Z̏Ԃɒ
  result := result.RoundToPrecision(pcs);             // w̐xɊۂ

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA

//  Form1.Memo1.Lines.Append('T.Ooura Big n = ' + intTostr(n));
end;

// tan(x)
// WJɂvZ xk[Cgp
//  -/2 < x < /2
function tan_Big(x: bigdecimal): bigdecimal;
var
//  t : array of biginteger;
//  k, nr, dpcs : integer;
  n, k, nr, dpcs, dpcsb: integer;
  b1, b2, q, g : biginteger;

  a2, c, d, dd, e, one, two : biginteger;

  s, sb, z, zz, az, m, seven : Bigdecimal;
  mf, pib, pi2, pis2, onef, x9, pi9: bigdecimal;

  flg : boolean;


  // xk[Cl\
  procedure memoout;
  var
    bstr : string;
  begin
    if b1 < 0 then bstr := ' = '
              else bstr := ' =  ';
    Form1.memo1.Lines.Append('B' + intTostr(n) + bstr + b1.ToString +' / ' + b2.ToString);
  end;

  // ő  [Nbȟݏ@
  function gcd_int(x, y: biginteger): biginteger;
  var
    t : biginteger;
  begin
    while y <> 0 do begin
      t := x mod y;
      x := y;
      y := t;
    end;
    result := x;
  end;

  // Tn̒lBnlɕϊ\
  procedure TntoBn;
  begin
    b1 := n * t[0];                                       // q  n * Tn
    q := q shl 2;                                         //   2^n  q = q * 4
    b2 := q * (q - one);                                  //  V   4^n  - 2^n
    g := gcd_int(b1, b2);                                 // ő
    b1 := b1 div g;
    b2 := b2 div g;
    if n mod 4 = 0 then b1 := - b1;                       // ݒ
//    memoout;                                              // l\
  end;

  // kɂxk[CvZ k = 2`
  procedure Bernoulli_number;
  var
    j: integer;
  begin
    // Seidel's algorithm for Tn  Bnlt[0]Ƃxk[CvZ[v B2`
    setlength(t, (k - 1) * 2 - 1);                              // zmہ@ǉzNA
    if k > 2 then begin
      for j := 0 to n - 2 do t[j + 1] := t[j] + t[j + 1];         // ->
      t[n] := t[n - 1];
      for j := n - 2  downto 0 do t[j + 1] := t[j] + t[j + 2];    // <-
      t[0] := t[1];
    end
    else begin
      t[0] := '1';                                                // qWl
      q := '1';                                                   // Wl
    end ;
    n := k * 2 - 2;                                               // n̒lݒ
    TntoBn;
  end;

begin
  dpcsb := Bigdecimal.DefaultPrecision;
  dpcs := dpcsb + 5;
  Bigdecimal.DefaultPrecision := dpcs;
  seven := '0.786';                                       // >45/4=0.78539816
  one := '1';
  two := '2';
  pib := big_pi(dpcs);
  pi2 := pib + pib;
  pis2 := pib / Two;
  repeat                                                  // 0`2(0`360)͈̔͂ɏC
    if x < 0 then x := x + pi2;
    if x >= pi2 then x := x - pi2;
  until (x < pi2) and (x >= 0);
  flg := true;                                            // tOZbg
  if (x > pis2) and (x < pib) then begin                  // 2` 90`180
    x := pib - x;                                           // 0`/2(0`90)͈̔͂ɏC
    flg := false                                            // tOݒ
  end;
  if (x >= pib) and (x < pib + pis2) then                 // ΁`+/2  180`270
    x := x - pib;                                           // 0`/2(0`90)͈̔͂ɏC
  if (x >= pib + pis2) and (x < pi2) then begin           // +/2`2 270`360
    x := pi2 - x;                                           // 0`/4(0`90)͈̔͂ɏC
    flg := false                                            // tOݒ
  end;
  x9 := x.RoundToPrecision(dpcsb);                        // pxw̌Ɋۂ
  pi9 := pis2.RoundToPrecision(dpcsb);                    // rad(90)w̌Ɋۂ
  if x9 = pi9 then begin                              // 90̏ꍇ
    application.MessageBox('[ŏZAȒlł','',0);
    result := 0;
    exit
  end;
  z := x;
  if x > seven then begin               // 0.786(45)𒴂ΊpvZ
    z := pib / two - z;
  end;
  c := 1;
  d := 1;
  e := 1;
  dd := '4';                            // 2^2
  s := '0';                             // =0
  az := z;                              // z
  zz := z * z;                          // z^2
  nr := 1;                              // n = 1 `
  repeat
    sb := s;                            // p sb
    k := nr + 1;                        // 2` xk[CvZp
    Bernoulli_number;                   // xk[CvZB(2n) b1 / b2
    a2 := nr * two;                     // 2n
    c := (a2 - one) * c * a2;           // (2n)!
    d := -d * dd;                       // -1^n * 2^2n
    e := e * dd;                        // 2^2n
    m := (one - e) * d * b1;            // ݂̂܂Ƃ߂ĐώZ
    mf := az * m;                       // _ * 
    mf := mf.RoundToPrecision(dpcs);    // ̏Zׂ̗̈Lۂ
    a2 := c * b2;                       //  * 
    mf := mf / a2;                      // _ / 
    s := s + mf;                        // 
    s := s.RoundToPrecision(dpcs);      // ׂ̗̈Lۂ
    az := az * zz;                      // z^2n-1
    inc(nr);                            // n = n + 1
  until sb = s;
  form1.Memo1.Lines.Append('Loop' + intTostr(nr - 1));
//  form1.Memo1.Lines.Append(s.ToPlainString);
  if x > seven then begin
    onef :=  '1';
    onef := onef.RoundToPrecision(dpcs);
    s := onef / s;                      // 0.786(45)𒴂ĂΊp
  end;
  if not flg then s := -s;
  Bigdecimal.DefaultPrecision := dpcsb;
  s := s.RoundToPrecision(dpcsb);
  s := s.RemoveTrailingZeros(0);
  result := s;
end;

// ͊mF
function TForm1.incheck(s, m: string): boolean;
const
  ec = 'e';
  eo = 'E';
  dt = '.';
var
  fs, es, ms : string;
  ch, p, po, leng : integer;
  a : double;
begin
  result := false;
  p := pos(ec, s);             // 'e' ̈ʒu
  po := pos(eo, s);            // 'E' ̈ʒu
  p := p + po;
  if p = 0 then begin          // 'e'  'E' 
    val(s, a, ch);
    if ch <> 0 then begin
      ms := m + ' ͒lɊԈႢ܂B';
      application.MessageBox(pchar(ms),'',0);
      exit;
    end;
    result := true;
    exit;
  end;
  leng := length(s);
  fs := '';
  fs := copy(s, 1, p - 1);          // 'e'̑O̕o
  es := '';
  es := copy(s, p + 1, leng - p);   // 'e'̌̕o
  val(fs, a, ch);
  if ch <> 0 then begin             // 'e'̑O̊̕mF
    ms := m + ' ͒lɊԈႢ܂B';
    application.MessageBox(pchar(ms),'',0);
    exit;
  end;
  if es <> '' then begin            // 'e'̌̕mF
    p := pos(ec, es);
    po := pos(eo, es);
    p := p + po;
    po := pos(dt, es);
    p := p + po;
    if p <> 0 then begin            // 'e','E' '.',JL
      ms := m + ' ͒lɊԈႢ܂B';
      application.MessageBox(pchar(ms),'',0);
      exit;
    end;
    val(es, a, ch);
    if ch <> 0 then begin
      ms := m + ' ͒lɊԈႢ܂B';
      application.MessageBox(pchar(ms),'',0);
      exit;
    end;
  end;
  result := true;
end;

procedure TForm1.tanXClick(Sender: TObject);
var
  deg, rad, ans, D180, dega : bigdecimal;
  dpcs, back, ch : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
  rmback : BigDecimal.RoundingMode;
begin
// ̓`FbN
  if not incheck(LabeledEdit1.Text, 'px') then exit;
  val(LabeledEdit2.Text, dpcs, ch);
  if ch <> 0 then begin
    application.MessageBox('LɊԈႢ܂', '', 0);
    exit;
  end;
  deg := LabeledEdit1.Text;
  dega := dega.Abs(deg);
  if dpcs > 1000 then begin
    application.MessageBox('L傫܂B','',0);
    exit;
  end;
  if (dpcs >= 500) and (dega > 10) and (dega < 75) then begin
    if MessageDlg('L傫ɎԂ|܂̂܂ܑs܂H',
        mtCustom, [mbOK,mbCancel], 0, mbCancel) = mrCancel then Exit;
  end;
  if (dpcs < 500) and (dpcs >= 300) and (dega > 10) and (dega < 75) then begin
    if MessageDlg('Ԃ|܂̂܂ܑs܂H',
        mtCustom, [mbOK,mbCancel], 0, mbCancel) = mrCancel then Exit;
  end;
  Form1.Edit1.text := 'vZ';
  application.ProcessMessages;
  back := Bigdecimal.DefaultPrecision;                // L
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[h

  Bigdecimal.DefaultPrecision := dpcs + 5;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  D180 := '180';
  rad := deg * big_pi(dpcs + 5);
  rad := rad.RoundToPrecision(dpcs + 5);

  rad := rad / D180;

  StopWatch := TStopwatch.StartNew;

// tan(x)
  Bigdecimal.DefaultPrecision := dpcs;
  ans := tan_big(rad);

  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Form1.Edit1.text := ' = ' + intTostr(ElapsedMillseconds) + 'msec';

// \
//  rad := rad.RoundToPrecision(dpcs div 2);
  memo1.Lines.Append('pxdeg =' + deg.ToPlainString);
//  memo1.Lines.Append('pxRAD =' + rad.ToPlainString);
  memo1.Lines.Append('tan(x)   =' + ans.ToPlainString);
  Bigdecimal.DefaultPrecision := back;                // L߂
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

procedure TForm1.ClearbtnClick(Sender: TObject);
begin
  memo1.Clear;
end;


end.

